/* FASTFOOD.CPP

    This program implements a POS system for a fast food
    restaurant.
 
    Author: B. King
    Rev. 1.0     04/15/98
*/

#include <iostream.h>
#include <iomanip.h>

double TakeOrder();
void GetPayment(double amt);

//****************************************************************
//***********                Prices              *****************
//****************************************************************

const double hamburgerPrice = 1.19,
             cheeseburgerPrice = hamburgerPrice + .20;

//****************************************************************
//***********                 Main              ******************
//****************************************************************

int main()

{
    char nextCustomer = 'y';
    double amt;

    while (nextCustomer == 'y') {
        amt = TakeOrder();
        if (amt > 0.)
            GetPayment(amt);

        cout << "Another customer (y/n) ? ";
        cin >> nextCustomer;
    }
    return 0;
}

//****************************************************************
//***********        TakeOrder, GetPayment           *************
//****************************************************************

double TakeOrder()

// Allows the operator to enter menu items.
// Returns the total order amount.

{
    double totalAmt = 0.;
    int howMany;
    char sandwich = '?';

    // Repeat while sandwich is not equal to blank
    while (sandwich != ' ') {

        // Prompt for the next item
        cout << "Next item (0 to quit) ==> ";

        // Input the number and type of sandwich
        cin >> howMany;
        if (howMany > 0)
            cin >> sandwich;
        else
            sandwich = ' ';

        // Add the price to the total amount
        if (sandwich == 'h')
            totalAmt = totalAmt + hamburgerPrice * howMany;
        else if (sandwich == 'c')
            totalAmt = totalAmt + cheeseburgerPrice * howMany;
    }

    return totalAmt;
}

void GetPayment(double amt)

// Displays order total, sales tax, and total amount due;
//   calculates change.

{
    const double taxRate = .05;         // Sales tax rate = 5%
    double taxAmt, moneyIn;

    cout << setprecision(2);   // Show two digits after the decimal
                               //   point.  Remains in effect until
                               //   changed.
    cout.setf(ios::showpoint | ios::fixed);
                               // Set flags to always show the
                               //   decimal point and trailing zeroes.
    // Some compilers may also require (usually default):
    cout.setf(ios::right, ios::adjustfield);
                               // Set flags to right-justify the output
                               //   in its field.

    cout << "Total:     " << setw(8) << amt << endl;
    taxAmt = amt * taxRate;
    cout << "Sales tax: " << setw(8) << taxAmt << endl;
    amt = amt + taxAmt;
    cout << "Total due: " << setw(8) << amt << endl;
    cout << "==> ";
    cin >> moneyIn;

    double change = moneyIn - amt;
    cout << "Change:    " << setw(8) << change << endl << endl;
}

