// ENCRYPT.CPP
//
//  This program encrypts a text file using a substuitute cypher.

#include <iostream.h>
#include <fstream.h>
#include <ctype.h>
#include "apvector.h"
#include "apstring.h"

// A lookup table for writing encoded messages.
static apvector<char> lookup(26);

char Encode(char c)

// Translates c through the lookup table. Changes only letters
//   and preserves the upper and lower case.

{
    char newC = c;
    char lowC = tolower(c);
    int i;

    if (lowC >= 'a' && lowC <= 'z') {
        i = lowC - 'a';
        newC = lookup[i];
        if (isupper(c))
            newC = toupper(newC);
    }

    return newC;
}

//****************************************************************

int main()

{
    apstring inpFileName, outpFileName;
    apstring key = "qwertyuiopasdfghjklzxcvbnm";
    char c;
    int i;

    // Set up the lookup table:
    for (i = 0;   i < 26;   i++)
        lookup[i] = key[i];    

    cout << "Input file: ";
    cin >> inpFileName;
    ifstream inpFile(inpFileName.c_str());
    if (!inpFile) {
        cout << "Can't open " << inpFileName << endl;
        return 1;
    }

    cout << "Output file: ";
    cin >> outpFileName;
    ofstream outpFile(outpFileName.c_str());
    if (!outpFile) {
        cout << "Can't open " << outpFileName << endl;
        return 1;
    }

    while (inpFile.get(c))
        outpFile.put(Encode(c));

    return 0;
}

