// LLQUEUE.CPP
//
// Queue implemented as a linked list.

#include "llqueue.h"

LLQUEUE::LLQUEUE()

// Constructor

{
    mFront = 0;
    mRear = 0;
}

//****************************************************************

LLQUEUE::~LLQUEUE ()

// Destructor: deletes all elements remaining in the queue.

{
    QNODE *next;

    while (mFront) {
        next = mFront->next;
        delete mFront;
        mFront = next;
    }
    mRear = 0;
}

//****************************************************************

void LLQUEUE::enqueue (const apstring &item)

// Inserts item at the rear of the queue.

{
    // Allocate a new node and copy info into it:
    QNODE *newnode = new QNODE;
    if (newnode) {
        newnode->info = item;
        newnode->next = 0;

        // Append the new node at the rear of the queue:
        if (mRear == 0)
            mFront = newnode;
        else
            mRear->next = newnode;
        mRear = newnode;
    }
}

//****************************************************************

void LLQUEUE::dequeue (apstring &item)

// Retrieves and removes the first element from the queue.

{
    // Retrieve the first element from the queue:
    if (mFront != 0) {
        item = mFront->info;

        // Remove the node from the front of the queue
        QNODE *next = mFront->next;
        delete mFront;
        mFront = next;
        if (mFront == 0) // If removed the last element...
            mRear = 0;
    }
}

//****************************************************************

bool LLQUEUE::isEmpty()

// Returns true if the queue is empty, false otherwise

{
    return mFront == 0;
}

