// PIZZA.CPP
//
// Pizza Plus Co. Home Deliveries
// Author: Roman Crust
// Rev 1.1


#include <iostream.h>
#include <ctype.h>
#include "apstring.h"
#include "apqueue.h"

struct ORDER {
    apstring items;
    apstring address;
};
          
int main()

{
    char key = ' ';
    ORDER order;
    apstring driverName;
    apqueue<ORDER> pendingOrders;
    apqueue<apstring> availDrivers;

    cout << "\n*** Pizza Plus Co. Home Deliveries ***\n\n";

    while (key != 'Q') {

        // Show menu, get next command:

        cout << "     (N)ew order\n";
        cout << "     (D)river available\n";        
        cout << "     (Q)uit\n";
        cout << "\n";
        cout << "Next command ==> ";
        cin >> key;
        cin.ignore(256, '\n');
        key = toupper(key);

        // Execute command:

        switch (key) {

          case 'N':    // Enter new order

            cout << "   Address ==> ";
            getline(cin, order.address);
            cout << "   Ordered Items ==> ";
            getline(cin, order.items);
            cout << "\n";

            pendingOrders.enqueue(order);
            cout << "<OK>\n";
            break;
            
          case 'D':    // Enter the name of available driver

            cout << "   Driver Name ==> ";
            getline(cin, driverName);
            cout << "\n";

            availDrivers.enqueue(driverName);
            cout << "<OK>\n";
            break;

          case 'Q':
            break;

          default:
            cout << "*** Invalid command ***\n";
            break;
        }

        // Dispatch available drivers to deliver pending orders 

        while (!availDrivers.isEmpty() && !pendingOrders.isEmpty()) {
            pendingOrders.dequeue(order);
            availDrivers.dequeue(driverName);
            cout << "\n\n*** Attention: " << driverName << "\n"
                 << "*\n" 
                 << "*      " << order.items << "\n"
                 << "*  to:\n"
                 << "*      " << order.address << "\n"
                 << "*******************\n\n";
        }
    }
    return 0;
}

