// RBQUEUE.H
//
// Queue implemented as a ring buffer.

#ifndef _RBQUEUE_H_
#define _RBQUEUE_H_
#include "bool.h"

class RBQUEUE {

  public:

    RBQUEUE(int size = 1024);
    ~RBQUEUE();
    void enqueue (char c);
    void dequeue (char &c);
    bool isEmpty();

  private:

    char *mBuffer;
    int mSize;
    int mFront;
    int mRear;

    // Private helper function that calculates the next
    //   index with wrap-around.
    int NextIndex(int index);
};

#endif    // _RBQUEUE_H_    

