// STACK.CPP
//
// Stack of integers implemented as an array.
//

#include "stack.h"

STACK::STACK(int size)

// Constructor: creates a stack of the specified size.
// (If fails, the size is set to 0.)

{
    mBuffer = new int[size];
    if (!mBuffer)
        mSize = 0;
    else
        mSize = size;
    mSp = 0;
}

//****************************************************************

void STACK::push(int item)

{
    if (mSp < mSize) {
        mBuffer[mSp] = item;  // Or, simply:
        mSp++;                //   mBuffer[mSp++] = item;
    }
}

//****************************************************************

void STACK::pop(int &item)

{
    if (mSp > 0) {
        mSp--;                // Or, simply:
        item = mBuffer[mSp];  //   item = mBuffer[--mSp];
    }
}

//****************************************************************

bool STACK::isEmpty()

{
    return mSp == 0;
}

//****************************************************************

STACK::~STACK()             

// Destructor: frees buffer.

{
    delete [] mBuffer;
}

