// TEST.CPP

#include <iostream.h>
#include "tree.h"

//****************************************************************

inline void Visit (TREENODE *node)

{
    cout << node->data << ' ';
}

void TraversePreOrder(TREENODE *root)

{
    if (!root) return;
    Visit(root);
    TraversePreOrder(root->left);
    TraversePreOrder(root->right);
}

void TraversePostOrder(TREENODE *root)

{
    if (!root) return;
    TraversePostOrder(root->left);
    TraversePostOrder(root->right);
    Visit(root);
}

void TraverseInOrder(TREENODE *root)

{
    if (!root) return;
    TraverseInOrder(root->left);
    Visit(root);
    TraverseInOrder(root->right);
}

//****************************************************************

int main()

{
    TREENODE *root = 0;

    Insert(root, "Mexico City");
    Insert(root, "Munich");
    Insert(root, "Montreal");
    Insert(root, "Moscow");
    Insert(root, "Los Angeles");
    Insert(root, "Seoul");
    Insert(root, "Barcelona");
    Insert(root, "Atlanta");
    Insert(root, "Sydney");

    cout << "Preorder:\n";
    TraversePreOrder(root);
    cout << "\n\n";

    cout << "Postorder:\n";
    TraversePostOrder(root);
    cout << "\n\n";

    cout << "Inorder:\n";
    TraverseInOrder(root);
    cout << "\n\n";

    Destroy(root);
    return 0;
}


